UNIT MNU;                                       {⥪ ᮧ }

INTERFACE                                       {p}

TYPE
    PMenu=^Menu;                                {⥫  ꥪ }
    Menu = object                               {ᠭ ꥪ }

    X,Y: Integer;                               {p ᯮ㥬  ꥪ}
    FLAG: Boolean;                              {ﭨ  롮p}
    MenuName: ARRAY[1..10,1..10] of String[80]; {ᨢ 㭪⮢ }
    TotalColumn: Integer;                       {⢮ 㭪⮢ }
    TotalRow, MaxLength: ARRAY[1..10] of integer;{⢮ 㭪⮢ }
    Selected: Integer;                          {p p 㭪}
    SubSelected: Integer;                       {p p 㭪}
    Buffer: array [1..4000] of byte;            {p  p ⥪}
    SubBuffer: array [1..80*24*10] of byte;     {p  p ⥪}

    CONSTRUCTOR Init;                           {pp 樠樨}
    PROCEDURE Add(MName: String);               { 㭪 }
    PROCEDURE SubAdd(MName: String);            { 㭪 }
    PROCEDURE Select(Var What: Integer);        {p楤p 롮p 㭪 }
    PROCEDURE RestoreSub;                       {⠭ p p}
    PROCEDURE SaveSub;                          {p p ( 맮 )}
    PROCEDURE Frame(FX,FY,FX1,FY1: INTEGER);    {뢮  p p}
    PROCEDURE Draw;                             {뢮  p }
     PROCEDURE Down;                            {pp    }
     PROCEDURE Up;                              {pp    p}
     PROCEDURE Left;                            {pp    }
     PROCEDURE Right;                           {pp    p}
     PROCEDURE Home;                            {pp  砫 ᯨ᪠}
     PROCEDURE ToEnd;                           {pp   ᯨ᪠}
    DESTRUCTOR Done;                            {pp p騩 p }
    END;

IMPLEMENTATION

USES CRT;

    CONSTRUCTOR Menu.Init;                      {樠樨 }
    var i: integer;                             {p}
    BEGIN                                       {砫}
         TotalColumn:=0;                        {ᥣ 㭪⮢ = 0}
         FOR i:=1 to 10 do                      {}
             TotalRow[i]:=1;                    {  㭪 1 㭪}
         FOR i:=1 to 10 do                      {}
             MaxLength[i]:=1;                   {ᨬ쭮 ⢮}
                                                {ᨬ  㭪}
         Selected:=1;                           { pp  = 1}
         SubSelected:=2;                        { pp  = 1}
         move(mem[$B800:0],buffer,4000);        {p ⪠ }
                                                { ᨢ p}
         i:=0;                                  {㫥 p p}
         while I<80*2 DO BEGIN                  {横  I < 80*2}
               mem[$b800:i]:=0;                 {80*2 - ⥪+p}
               mem[$b800:i+1]:=20;              {塞 1 p ᨬ}
               INC(i,2);
         END;
          TEXTBACKGROUND(3);                    {⠭ 梥 p}
         SaveSub;                               {p p}
    END;

    PROCEDURE Menu.Down;
    BEGIN
     INC(SubSelected);
      IF SubSelected > TotalRow[Selected] THEN SubSelected:=2;
      FLAG:=FALSE;
     Menu.Draw;
    END;

    PROCEDURE Menu.Up;
    BEGIN
     DEC(SubSelected);
      IF SubSelected <2 THEN SubSelected:=TotalRow[Selected];
      FLAG:=FALSE;
     Menu.Draw;
    END;

    PROCEDURE Menu.Left;
    BEGIN
    FLAG:=TRUE;
     DEC(Selected);
      IF Selected < 1 THEN Selected:=TotalColumn;
       IF SubSelected < 2 THEN SubSelected:=2;
      IF SubSelected > TotalRow[Selected] THEN
       SubSelected:=TotalRow[Selected];
     RestoreSub;
    Menu.Draw;
    END;

    PROCEDURE Menu.Right;
    BEGIN
    FLAG:=TRUE;
     INC(Selected);
      IF Selected > TotalColumn THEN Selected:=1;
       IF SubSelected < 2 THEN SubSelected:=2;
      IF SubSelected > TotalRow[Selected] THEN
       SubSelected:=TotalRow[Selected];
     RestoreSub;
    Menu.Draw;
    END;

    PROCEDURE Menu.Home;
    BEGIN
     SubSelected:=2;
      FLAG:=FALSE;
     Menu.Draw;
    END;

    PROCEDURE Menu.ToEnd;
    BEGIN
     SubSelected:=TotalRow[Selected];
      FLAG:=FALSE;
     Menu.Draw;
    END;

    PROCEDURE Menu.Select(VAR What: Integer);
    VAR Key: Char;
    BEGIN
     FLAG:=TRUE;
     Menu.Draw;
     Repeat
       Key:=Readkey;
       case Key of
        #77: Menu.Right;
        #75: Menu.Left;
        #80: Menu.Down;
        #72: Menu.Up;
        #71: Menu.Home;
        #79: Menu.ToEnd;

        #13: What:=((Selected*10)+SubSelected);
        #27: What:=0;
       END;
     Until (Key=#13) or (Key=#27);
    END;

    PROCEDURE Menu.Add(MName: String);
    BEGIN
       Inc(TotalColumn);
       MenuName[TotalColumn,1]:=MName;
    END;

    PROCEDURE Menu.SubAdd(MName: String);
    BEGIN
       Inc(TotalRow[TotalColumn]);
       MenuName[TotalColumn,TotalRow[TotalColumn]]:=MName;
       IF Length(MName)>MaxLength[TotalColumn]
        THEN MaxLength[TotalColumn]:=Length(MName);
    END;

    PROCEDURE Menu.Frame;
    VAR I1 : INTEGER;
    BEGIN
     WINDOW(FX, FY, FX1, FY1);
      TEXTCOLOR(15);TEXTBACKGROUND(1);
     CLRSCR;
     WINDOW(1, 1, 80, 25);
     FOR I1:=FX TO FX1
      DO BEGIN
         GOTOXY(I1,FY);WRITE('');
         GOTOXY(I1,FY1);WRITE('');
      END;

      FOR I1:=FY TO FY1
      DO BEGIN
         GOTOXY(FX,I1);WRITE('');
         GOTOXY(FX1,I1);WRITE('');
      END;

      GOTOXY(FX,FY);WRITE('');
      GOTOXY(FX1,FY);WRITE('');
      GOTOXY(FX,FY1);WRITE('');
      GOTOXY(FX1,FY1);WRITE('');
    END;

    PROCEDURE Menu.Draw;
    VAR
       i,i1,i3,l: integer;
    BEGIN

    l:=1;
        FOR i:=1 TO TotalColumn do
         BEGIN
          IF (i=selected) and (Flag=true) and (TotalRow[Selected]>1)
           THEN
            Menu.Frame(l,2,l+MaxLength[Selected]+1,TotalRow[Selected]+2);

           IF (i=Selected) THEN BEGIN
                                 TextBackground(1);
                                 TextColor(15);
                                END

              ELSE BEGIN TextBackground(1);
                         Textcolor(11);
                   END;
            GOTOXY(1+l,1); WRITE(MenuName[i,1]);

           IF (i=Selected) THEN
           BEGIN
             FOR i1:=2 to TotalRow[Selected] DO { }
                 BEGIN
                  IF i1=SubSelected THEN
                   BEGIN
                    TextBackground(3);
                    TextColor(15);
                   END
                     ELSE BEGIN
                           TextBackground(1);
                           TextColor(11);
                          END;
                  GOTOXY(1+l,i1+1);WRITE(MenuName[Selected,i1]);
                  {FOR i3:=length(MenuName[Selected,i1])
                   TO MaxLength[Selected]-1 DO WRITE(' ');}{. p}
                 END;
            END;

            l:=l+length(MenuName[i,1]);
           END;
           GOTOXY(80,25);
    END;

    PROCEDURE Menu.RestoreSub;
    BEGIN
     move(subbuffer,mem[$B800:80*2],sizeof(subbuffer));
    END;

    PROCEDURE Menu.SaveSub;
    BEGIN
     move(mem[$B800:80*2],subbuffer,sizeof(subbuffer));
    END;

    DESTRUCTOR Menu.Done;
    BEGIN
         move(buffer,mem[$B800:0],4000);        {⠭ p}
    END;
BEGIN
END.