UNIT TEXTLIB; {    }

INTERFACE { }

         PROCEDURE PACKSPACE(VAR S: STRING);
         { " "}
         PROCEDURE SEARCHALL(S: STRING);
         {       S}
         PROCEDURE SEARCHROT (S: STRING);
         {      ""}
         PROCEDURE PACKSTR(VAR S: STRING);
         {    ,   }
         PROCEDURE CMPSEARCH(S: STRING; W1: STRING);
         {  S         W1}
         PROCEDURE ALLCHAR(S: STRING);
         {       S}
         PROCEDURE MAXNUM(S: STRING; VAR SUM, MAX: INTEGER);
         {  -   ,     S}
         PROCEDURE REPLACE(VAR S: STRING; W1, W2: STRING);
         {  W1  W2   S}
         PROCEDURE DOUBLECH(VAR S: STRING; CH: CHAR);
         {  CH   S}
         PROCEDURE FINDWORD(S: STRING);
         {   S,    
          }

         FUNCTION STRMOD(S: STRING; N: INTEGER): STRING;
         {     3}
         FUNCTION PACKCHAR(S: STRING): STRING;
         {      }
         FUNCTION SUMCHAR(VAR S: STRING; CH: CHAR): INTEGER;
         {()   CH   S}
         FUNCTION COMPARE(W1,W2: STRING): BOOLEAN;
         {  W1  W2   
          }
         FUNCTION ROTATET(S: STRING):STRING;
         {   S}
         FUNCTION PREPPOS(S: STRING; P: INTEGER): INTEGER;
         {     S   P}
         FUNCTION SEARCH(VAR S: STRING; W1: STRING): INTEGER;
         {()     W1  S}
         FUNCTION RECODE(S: STRING): STRING;
         { ""  S}

IMPLEMENTATION { }

CONST   PREP = ['-',',','.',';',':','"',' ','!','*','(',')',#09];
{   }
{--------------------------------------------------------------------------}
PROCEDURE PACKSPACE(VAR S: STRING);    { }
VAR I, N: INTEGER;                     { }
BEGIN                                  { }
  N:=1;                                {N -   ""}
   WHILE N>0 DO BEGIN                  {  N>0}
    N:=0;                              {  }
     FOR I:=1 TO LENGTH(S)-1 DO        { FOR  I<  }
      BEGIN                            { 1}
       IF S[I]=' ' THEN                { S[I]="" }
          IF (S[I+1]=' ') THEN         {     }
           BEGIN                       { 2}
                DELETE(S,I,1);         {  }
                INC(N);                {    1}
           END;                        { 2}
      END;                             { 1}
   END;                                {  "WHILE"}
END;                                   { }
{--------------------------------------------------------------------------}
FUNCTION ROTATET(S: STRING):STRING;    { }
 VAR    I,LEN   : INTEGER;             { }
        TMP: STRING;
BEGIN                                  { }
 TMP:=S;                               {  = S}
 LEN:=LENGTH(TMP);                     {LEN =   }
  FOR I:=1 TO LEN DO                   {  I  LEN}
   BEGIN                               { }
     TMP[I]:=S[LEN-I+1];               { TMP[I] =  S[LEN-I+1]}
   END;                                { }
ROTATET:=TMP;                          {  TMP}
END;                                   { }
{--------------------------------------------------------------------------}
FUNCTION PREPPOS(S: STRING; P: INTEGER): INTEGER; { }
VAR      I, LEN: INTEGER;              { }
BEGIN                                  { }
 I:=P;                                 {I=P, P -  }
 LEN:=LENGTH(S);                       {LEN=(S)}
    REPEAT                             {  REPEAT}
      INC(I);                          { I}
    UNTIL (S[I] IN PREP) OR (I=LEN+1); {  REPEAT}
    IF I=LEN+1 THEN PREPPOS:=0         { I=   PREPOS=0}
   ELSE PREPPOS:=I;                    { PREPOS = I}
END;                                   { }
{--------------------------------------------------------------------------}
PROCEDURE FINDWORD(S: STRING);         { }
VAR W1: STRING;                        { }
    COUNTER, POSIT1, POSIT2: INTEGER;
BEGIN                                  { }
     COUNTER:=0;                       { = 0}
     POSIT1:=0;                        { = 0}
REPEAT                                 { REPEAT}
  POSIT2:=PREPPOS(S,POSIT1);           { =   }
                                       {}
  IF POSIT2=0 THEN POSIT2:=LENGTH(S)+1;{  = 0   = }
                                       { S+1}
  W1:=COPY(S,POSIT1+1,POSIT2-POSIT1-1);{ ""  W1}
  IF W1[1]=W1[LENGTH(W1)] THEN WRITELN(W1);{   =
                                          W1}
  POSIT1:=POSIT2;                      {1 = 2}
UNTIL POSIT2=LENGTH(S)+1;              { 2 <> (S)+1}
END;                                   { }
{--------------------------------------------------------------------------}
FUNCTION SEARCH(VAR S: STRING; W1: STRING): INTEGER;{ }
VAR      W2: STRING;                   { }
         COUNTER: INTEGER;
         POSIT1, POSIT2: INTEGER;
BEGIN                                  { }
         COUNTER:=0;                   { = 0}
         POSIT1:=0;POSIT2:=0;          {1=2=0}
REPEAT                                 { REPEAT}
 POSIT1:=POSIT2;                       {1=2}
 POSIT2:=PREPPOS(S, POSIT1);           {2= 1  .}
 IF POSIT2=0 THEN POSIT2:=LENGTH(S)+1; {  = 0   = }
                                       { S+1}
 W2:= COPY(S, POSIT1+1, POSIT2-POSIT1-1);{ ""  W2}
 IF W2=W1 THEN BEGIN                   { W2= W1 }
  DELETE(S, POSIT1+1, POSIT2-POSIT1-1);{   S}
   INC(COUNTER);                       {   1}
  POSIT2:=POSIT1;                      {2=1 -  }
 END;                                  { }
UNTIL POSIT2=LENGTH(S)+1;              { 2 <> (S)+1}
SEARCH:=COUNTER;                       {  }
END;                                   { }
{--------------------------------------------------------------------------}
PROCEDURE SEARCHALL(S: STRING);        { }
VAR W1, W2: STRING;                    { }
    COUNTER, POSIT1, POSIT2: INTEGER;
BEGIN                                  { }
POSIT1:=0; POSIT2:=0;                  {1=2=0}
REPEAT                                 { REPEAT}
   POSIT1:=POSIT2;                     {1=2}
   POSIT2:=PREPPOS(S,POSIT1);          {2= 1  .}
   IF POSIT2 = 0 THEN POSIT2:=LENGTH(S)+1;{  = 0   =
                                        S+1}
   W1:=COPY(S,POSIT1+1,POSIT2-POSIT1-1);{ ""  W1}
   IF W1<>'' THEN BEGIN                { W1 <>'' -  "" }
         POSIT1:=0; POSIT2:=0;         {1=2=0}
          COUNTER:=SEARCH(S,W1);       {=  W1  S}
         WRITELN(COUNTER,'-',W1);      { }
      END;                             { }
UNTIL POSIT2=LENGTH(S)+1;              { 2 <> (S)+1}
END;                                   { }
{--------------------------------------------------------------------------}
FUNCTION RECODE(S: STRING): STRING;    { }
VAR W1, W2, NUM, NEW: STRING;          { }
    COUNTER, POSIT1, POSIT2: INTEGER;
BEGIN                                  { }
    POSIT1:=0; POSIT2:=0;              {1=2=0}
    NEW:='';                           { =''}
REPEAT                                 { REPEAT}
    POSIT1:=POSIT2;                    {1=2}
    POSIT2:=PREPPOS(S,POSIT1);         {2= 1  .}
    IF POSIT2 = 0 THEN POSIT2:=LENGTH(S)+1;{  = 0   =
                                        S+1}
    W1:=COPY(S,POSIT1+1,POSIT2-POSIT1-1);{   W1}

    IF W1<>'' THEN BEGIN               { W1  "" }
    POSIT1:=0; POSIT2:=0;              {1=2=0}
    COUNTER:=SEARCH(S,W1);             {=-  W1  S}
    STR(COUNTER,NUM);                  {    .}
    NEW:=NEW+NUM+W1+' ';               {NEW=NEW+(NUM)+(W1)}
    END;                               { }
UNTIL POSIT2=LENGTH(S)+1;              { 2 <> (S)+1}
RECODE:=NEW;                           {  }
END;                                   { }
{--------------------------------------------------------------------------}
PROCEDURE PACKSTR(VAR S: STRING);      { }
VAR W1, W2, CH, NEW: STRING;           { }
    COUNTER, POSIT1, POSIT2: INTEGER;  {}
BEGIN                                  { }
POSIT1:=0; POSIT2:=0;                  {1=2=0}
NEW:='';                               {NEW -  }
REPEAT                                 { REPEAT}
      POSIT1:=POSIT2;                  {1=2}
      POSIT2:=PREPPOS(S,POSIT1);       {2= 1  .}
      IF POSIT2 = 0 THEN POSIT2:=LENGTH(S)+1;{  = 0   =
                                        S+1}
      W1:=COPY(S,POSIT1+1,POSIT2-POSIT1-1);{   W1}
        CH:=COPY(S,POSIT2,1);          {   }
      IF W1<>'' THEN BEGIN             { W1   }
       POSIT1:=0; POSIT2:=0;           {1=2=0}
       COUNTER:=SEARCH(S,W1);          {() W1  S}
       NEW:=NEW+W1+CH;                 {NEW=NEW++}
      END;                             { }
UNTIL POSIT2=LENGTH(S)+1;              { 2 <> (S)+1}
S:=NEW;                                {  = }
END;                                   {}
{--------------------------------------------------------------------------}
PROCEDURE SEARCHROT (S: STRING);       { }
VAR W1, W2: STRING;                    { }
    COUNTER, POSIT1, POSIT2: INTEGER;  {}
BEGIN                                  { }
POSIT1:=0; POSIT2:=0;                  {1=2=0}
REPEAT                                 { REPEAT}
      POSIT1:=POSIT2;                  {1=2}
      POSIT2:=PREPPOS(S,POSIT1);       {2=   POSIT1}
      IF POSIT2 = 0 THEN POSIT2:=LENGTH(S)+1;
      W1:=COPY(S,POSIT1+1,POSIT2-POSIT1-1);{   S  W1}
      IF W1<>'' THEN BEGIN             { W1   }
      POSIT1:=0; POSIT2:=0;            {1=2=0}
      COUNTER:=SEARCH(S,ROTATET(W1));  {()  W1  S}
      IF COUNTER>0 THEN WRITELN(W1,' - ',ROTATET(W1));{ W1  ROTATET(W1)}
      COUNTER:=SEARCH(S,W1);           {() W1  S}
      END;                             { }
UNTIL POSIT2=LENGTH(S)+1;              { 2 <> (S)+1}
END;                                   { }
{--------------------------------------------------------------------------}
FUNCTION STRMOD(S: STRING; N: INTEGER): STRING; { }
VAR NUM, CODE: INTEGER;                 { }
BEGIN                                   { }
     REPEAT                             { REPEAT}
       VAL(S, NUM, CODE);               {   }
       IF CODE<>0 THEN DELETE(S,CODE,1);{    
                                           }
     UNTIL (CODE=0) OR (CODE=1);        {    " "}

     IF CODE=1 THEN STRMOD:='  '{ =1    }
      ELSE                              {}
        IF (NUM MOD N)=0 THEN STRMOD:=' 3'{   3}
        ELSE STRMOD:=' 3';      {   3}
END;                                    { }
{--------------------------------------------------------------------------}
PROCEDURE REPLACE(VAR S: STRING; W1, W2: STRING);{ }
VAR W3: STRING;                         { }
POSIT1, POSIT2: INTEGER;                {}
BEGIN                                   { }
POSIT1:=0;POSIT2:=0;                    {1=2=0}
REPEAT                                  { REPEAT}
      POSIT1:=POSIT2;                   {1=2}
      POSIT2:=PREPPOS(S, POSIT1);       {2=   POSIT1}
      IF POSIT2=0 THEN POSIT2:=LENGTH(S)+1;{}
      W3:= COPY(S, POSIT1+1, POSIT2-POSIT1-1);{   S  W3}
      IF W3=W1 THEN                     { W3=W1 }
      BEGIN                             { }
      DELETE(S, POSIT1+1, POSIT2-POSIT1-1);{  W3}
      INSERT(W2,S,POSIT1+1);            {  W2}
      POSIT2:=POSIT1;                   { }
      END;                              { }
UNTIL POSIT2=LENGTH(S)+1;               { 2 <> (S)+1}
END;                                    { }
{--------------------------------------------------------------------------}
PROCEDURE MAXNUM(S: STRING; VAR SUM, MAX: INTEGER);{ }
VAR POSIT, NUM, LEN, CODE, N: INTEGER;  { }
    W1: STRING;                         {}
CONST NUMBERS=['0','1'..'9'];           { }
BEGIN                                   { }
LEN:=LENGTH(S);                         {LEN=(S)}
POSIT:=0; MAX:=0; SUM:=0;               { }
     REPEAT                             {  REPEAT}
       INC(POSIT);                      {(POSIT)}
       IF S[POSIT] IN NUMBERS THEN      {  S[POSIT] -  }
       BEGIN                            { 1}
          W1:=S[POSIT];                 {W1= S[POSIT]}
          VAL(W1,NUM,CODE);             {   }
          INC(SUM,NUM);                 {  SUM  NUM}
          N:=0;                         { }
      WHILE S[POSIT] IN NUMBERS DO BEGIN{ WHILE}
          INC(N); INC(POSIT);           { N  POSIT}
           W1:=S[POSIT];                {W1= S[POSIT]}
            VAL(W1,NUM,CODE);           {   }
           INC(SUM,NUM);                {  SUM  NUM}
      END;                              {  WHILE}
        IF N>MAX THEN MAX:=N;           { N  MAX  MAX=N}
        END;                            { 1}
     UNTIL POSIT=LEN+1;                 {  <> LEN+1}
END;                                    { }
{--------------------------------------------------------------------------}
FUNCTION SUMCHAR(VAR S: STRING; CH: CHAR): INTEGER; { }
VAR POSIT, COUNT: INTEGER;              { }
BEGIN                                   { }
POSIT:=0; COUNT:=0;                     { }
REPEAT                                  {  REPEAT}
      INC(POSIT);                       {(POSIT)}
      IF S[POSIT]=CH THEN               { S[POSIT]=  }
        BEGIN                           { }
             INC(COUNT);                {(COUNT)}
              DELETE(S,POSIT,1);        {   S}
             DEC(POSIT);                {(POSIT)}
        END;                            { }
UNTIL (POSIT=LENGTH(S)) OR (LENGTH(S)=0);{  <> (S)}
SUMCHAR:=COUNT;                         {  COUNT}
END;                                    { }
{--------------------------------------------------------------------------}
PROCEDURE ALLCHAR(S: STRING);           { }
VAR POSIT, COUNT: INTEGER;              { }
    CH: CHAR;
BEGIN                                   { }
IF LENGTH(S)>0 THEN
REPEAT                                  { REPEAT}
      CH:=S[1];                         {CH= }
      COUNT:=SUMCHAR(S,CH);             {()  CH  S}
      WRITE('"',CH,'" - ',COUNT,'; ');  {}
UNTIL LENGTH(S)=0;                      {  S<>0}
END;                                    { }
{--------------------------------------------------------------------------}
FUNCTION PACKCHAR(S: STRING): STRING;   { }
VAR POSIT, COUNT: INTEGER;              { }
    CH: CHAR;
    S2: STRING;
BEGIN                                   { }
S2:='';                                 { S2}
REPEAT                                  {  REPEAT}
      CH:=S[1];                         {CH= }
      COUNT:=SUMCHAR(S,CH);             {()  CH  S}
      IF COUNT=1 THEN S2:=S2+CH;        {  =1  S2=S2+CH}
UNTIL LENGTH(S)=0;                      {  S<>0}
PACKCHAR:=S2;                           { S2}
END;                                    { }
{--------------------------------------------------------------------------}
FUNCTION COMPARE(W1,W2: STRING): BOOLEAN;{ }
VAR POSIT, COUNT, COUNT2: INTEGER;      { }
    CH: CHAR;                           {}
    S2: STRING;                         {}
BEGIN                                   { }
IF (LENGTH(W1)>0) AND (LENGTH(W1)=LENGTH(W2)) AND (W1<>W2) THEN
   BEGIN                                { }
        REPEAT                          { REPEAT}
              CH:=W1[1];                {CH= }
              COUNT:=SUMCHAR(W1,CH);    {  CH  W1}
              COUNT2:=SUMCHAR(W2,CH);   {  CH  W2}
        UNTIL (LENGTH(W1)=0) OR (COUNT<>COUNT2);{  W1<>0
                                            }
   IF LENGTH(W1)=0 THEN COMPARE:=TRUE   { (W1)=0  }
      ELSE COMPARE:=FALSE;              { }
   END                                  { }
ELSE COMPARE:=FALSE;                    {}
END;                                    { }
{--------------------------------------------------------------------------}
PROCEDURE CMPSEARCH(S: STRING; W1: STRING);{ }
VAR W2: STRING;                         { }
    COUNTER: INTEGER;                   {}
    POSIT1, POSIT2: INTEGER;            {}
BEGIN                                   { }
    COUNTER:=0;                         { }
    POSIT1:=0;POSIT2:=0;
REPEAT                                  { REPEAT}
    POSIT1:=POSIT2;                     {}
    POSIT2:=PREPPOS(S, POSIT1);         {POSIT2= PREP  POSIT1}
    IF POSIT2=0 THEN POSIT2:=LENGTH(S)+1;
    W2:= COPY(S, POSIT1+1, POSIT2-POSIT1-1);{   S  W2}
    IF COMPARE(W1,W2)=TRUE THEN BEGIN   { "" }
     DELETE(S, POSIT1+1, POSIT2-POSIT1-1);{   S}
      IF COUNTER=0 THEN WRITE(W1,': '); { =0   W1}
      WRITE(W2,' ');                    {(W2)}
      INC(COUNTER);                     {()}
      POSIT2:=POSIT1;                   {POSIT2=POSIT1}
    END;                                { }
UNTIL POSIT2=LENGTH(S)+1;               { POSIT2<>(S)+1}
WRITELN;                                {  }
END;                                    { }
{--------------------------------------------------------------------------}
PROCEDURE DOUBLECH(VAR S: STRING; CH: CHAR);{ }
VAR POSIT: INTEGER;                     { }
BEGIN                                   { }
POSIT:=0;                               { POSIT}
REPEAT                                  { REPEAT}
      INC(POSIT);                       {(POSIT)}
      IF S[POSIT]=CH THEN               { S[POSIT]= CH }
       BEGIN                            { }
            INSERT(CH,S,POSIT);         {  CH  S}
            INC(POSIT);                 {(POSIT)}
       END;                             { }
UNTIL POSIT=LENGTH(S);                  { POSIT<>(S)}
END;                                    { }
{--------------------------------------------------------------------------}
BEGIN { }
END.  {  }